---
title: MediaTrackConstraints.logicalSurface
slug: Web/API/MediaTrackConstraints/logicalSurface
tags:
  - API
  - Capture
  - Constraints
  - Media
  - Media Capture and Streams
  - Media Capture and Streams API
  - MediaTrackConstraints
  - Property
  - Reference
  - Screen Capture
  - Screen Capture API
  - Sharing
  - Video
  - display
  - logicalSurface
  - screen
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p><span class="seoSummary">The {{domxref("MediaTrackConstraints")}} dictionary's <strong><code>logicalSurface</code></strong> property is a {{domxref("ConstrainDOMString")}} describing the requested or mandatory constraints placed upon the value of the {{domxref("MediaTrackSettings.logicalSurface", "logicalSurface")}} constrainable property.</span> This is used to specify whether or not {{domxref("MediaDevices.getDisplayMedia", "getDisplayMedia()")}} should allow the user to choose display surfaces which are not necessarily fully visible on the screen, such as occluded windows or the complete content of windows which are large enough to require scrolling to see their entire contents.</p>

<p>If needed, you can determine whether or not this constraint is supported by checking the value of {{domxref("MediaTrackSupportedConstraints.logicalSurface")}} as returned by a call to {{domxref("MediaDevices.getSupportedConstraints()")}}. However, typically this is unnecessary since browsers will ignore any constraints they're unfamiliar with.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>constraintsObject</em> = { logicalSurface: <em>constraint</em> };

<em>constraintsObject</em>.logicalSurface = <em>constraint</em>;
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("ConstrainBoolean")}} which is <code>true</code> if logical surfaces should be permitted among the selections available to the user.</p>

<p>See {{SectionOnPage("/en-US/docs/Web/API/Media_Streams_API/Constraints", "How constraints are defined")}} for an explanation of how to define constraints.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>You can check the setting selected by the user agent after the display media has been created by {{domxref("MediaDevices.getDisplayMedia", "getDisplayMedia()")}} by calling {{domxref("MediaStreamTrack.getSettings", "getSettings()")}} on the display media's video {{domxref("MediaStreamTrack")}}, then checking the value of  the returned {{domxref("MediaTrackSettings")}} object's {{domxref("MediaTrackSettings.logicalSurface", "logicalSurface")}} object.</p>

<p>For example, if your app needs to know if the selected display surface is a logical one:</p>

<pre class="brush: js">let isLogicalSurface = displayStream.getVideoTracks()[0].getSettings().logicalSurface;
</pre>

<p>Following this code, <code>isLogicalSurface</code>  is <code>true</code> if the display surface contained in the stream is a logical surface; that is, one which may not be entirely onscreen, or may even be entirely offscreen.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('Screen Capture', '#dom-mediatrackconstraintset-logicalsurface', 'MediaTrackConstraints.logicalSurface') }}</td>
   <td>{{ Spec2('Screen Capture') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaTrackConstraints.logicalSurface")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Screen_Capture_API">Screen Capture API</a></li>
 <li><a href="/en-US/docs/Web/API/Screen_Capture_API/Using_Screen_Capture">Using the Screen Capture API</a></li>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">Capabilities, constraints, and settings</a></li>
 <li>{{domxref("MediaTrackConstraints")}}</li>
 <li>{{domxref("MediaDevices.getSupportedConstraints()")}}</li>
 <li>{{domxref("MediaTrackSupportedConstraints")}}</li>
</ul>
